/*-
 * Copyright 2008 Jason Harmening
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef __CX88_VIDEO_REGS_H__
#define __CX88_VIDEO_REGS_H__

#define CX23880_VIDEO_REG_Y_GP_COUNT       0x31C020
#define CX23880_VIDEO_REG_Y_GP_COUNT_CTL   0x31C030

#define CX23880_VIDEO_REG_U_GP_COUNT       0x31C024
#define CX23880_VIDEO_REG_U_GP_COUNT_CTL   0x31C034

#define CX23880_VIDEO_REG_V_GP_COUNT       0x31C028
#define CX23880_VIDEO_REG_V_GP_COUNT_CTL   0x31C038

#define CX23880_VIDEO_REG_VBI_GP_COUNT     0x31C02C
#define CX23880_VIDEO_REG_VBI_GP_COUNT_CTL 0x31C03C

#define CX23885_VIDA_REG_GP_COUNT          0x130020
#define CX23885_VIDA_REG_GP_COUNT_CTL      0x130030

#define CX23885_VIDA_REG_VBI_GP_COUNT      0x130024
#define CX23885_VIDA_REG_VBI_GP_COUNT_CTL  0x130034

#define CX23885_VIDB_REG_GP_COUNT          0x130120
#define CX23885_VIDB_REG_GP_COUNT_CTL      0x130130

#define CX23885_VIDB_REG_VBI_GP_COUNT      0x130124
#define CX23885_VIDB_REG_VBI_GP_COUNT_CTL  0x130134

#define CX23880_VIDEO_REG_DMA_CONTROL      0x31C040
#define CX23885_VIDA_REG_DMA_CONTROL       0x130040
#define CX23885_VIDB_REG_DMA_CONTROL       0x130140
#define CX23880_VIDEO_VBI_RISC_ENABLE      (1 << 7)
#define CX23880_VIDEO_V_RISC_ENABLE        (1 << 6)
#define CX23880_VIDEO_U_RISC_ENABLE        (1 << 5)
#define CX23885_VIDEO_VBI_RISC_ENABLE      (1 << 5)
#define VIDEO_Y_RISC_ENABLE                (1 << 4)
#define VIDEO_RISC_ENABLE_MASK             0xF0
#define CX23880_VIDEO_VBI_FIFO_ENABLE      (1 << 3)
#define CX23880_VIDEO_V_FIFO_ENABLE        (1 << 2)
#define CX23880_VIDEO_U_FIFO_ENABLE        (1 << 1)
#define CX23885_VIDEO_VBI_FIFO_ENABLE      (1 << 1)
#define VIDEO_Y_FIFO_ENABLE                (1 << 0)
#define VIDEO_FIFO_ENABLE_MASK             0xF

#define CX23885_VIDEO_A_REG_INT_MASK       0x040020
#define CX23885_VIDEO_A_REG_INT_STAT       0x040024
#define CX23885_VIDEO_A_REG_INT_MSTAT      0x040028
#define CX23885_VIDEO_A_REG_INT_SSTAT      0x04002C
#define CX23885_VIDEO_B_REG_INT_MASK       0x040030
#define CX23885_VIDEO_B_REG_INT_STAT       0x040034
#define CX23885_VIDEO_B_REG_INT_MSTAT      0x040038
#define CX23885_VIDEO_B_REG_INT_SSTAT      0x04003C
#define CX23880_VIDEO_REG_INT_MASK         0x200050
#define CX23880_VIDEO_REG_INT_STAT         0x200054
#define CX23880_VIDEO_REG_INT_MSTAT        0x200058
#define CX23880_VIDEO_REG_INT_SSTAT        0x20005C
#define CX23880_VIDEO_INT_PCI_ABORT        (1 << 19)
#define CX23880_VIDEO_INT_RIP_ERR          (1 << 18)
#define CX23880_VIDEO_INT_PAR_ERR          (1 << 17)
#define CX23885_VIDEO_INT_VBI_OPCODE_ERR   (1 << 17)
#define VIDEO_INT_OPCODE_ERR               (1 << 16)
#define CX23880_VIDEO_INT_VBI_SYNC         (1 << 15)
#define CX23880_VIDEO_INT_V_SYNC           (1 << 14)
#define CX23880_VIDEO_INT_U_SYNC           (1 << 13)
#define CX23885_VIDEO_INT_VBI_SYNC         (1 << 13)
#define VIDEO_INT_Y_SYNC                   (1 << 12)
#define CX23880_VIDEO_INT_VBI_OVERFLOW     (1 << 11)
#define CX23880_VIDEO_INT_V_OVERFLOW       (1 << 10)
#define CX23880_VIDEO_INT_U_OVERFLOW       (1 << 9)
#define CX23885_VIDEO_INT_VBI_OVERFLOW     (1 << 9)
#define VIDEO_INT_Y_OVERFLOW               (1 << 8)
#define CX23880_VIDEO_INT_VBI_RISCI2       (1 << 7)
#define CX23880_VIDEO_INT_V_RISCI2         (1 << 6)
#define CX23880_VIDEO_INT_U_RISCI2         (1 << 5)
#define CX23885_VIDEO_INT_VBI_RISCI2       (1 << 5)
#define VIDEO_INT_Y_RISCI2                 (1 << 4)
#define CX23880_VIDEO_INT_VBI_RISCI1       (1 << 3)
#define CX23880_VIDEO_INT_V_RISCI1         (1 << 2)
#define CX23880_VIDEO_INT_U_RISCI1         (1 << 1)
#define CX23885_VIDEO_INT_VBI_RISCI1       (1 << 1)
#define VIDEO_INT_Y_RISCI1                 (1 << 0)

#endif
